---
title: HTMLMediaElement.captureStream()
slug: Web/API/HTMLMediaElement/captureStream
tags:
  - API
  - Audio
  - HTML DOM
  - HTMLMediaElement
  - Media
  - Media Capture DOM Elements
  - Method
  - Reference
  - Video
  - captureStream
---
<div>{{APIRef("HTML Media Capture")}}</div>

<p>The <strong><code>captureStream()</code></strong> property of the {{domxref("HTMLMediaElement")}} interface returns a {{domxref('MediaStream')}} object which is streaming a real-time capture of the content being rendered in the media element.</p>

<p>This can be used, for example, as a source for a <a href="/en-US/docs/Web/API/WebRTC_API">WebRTC</a> {{domxref("RTCPeerConnection")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>mediaStream</em> = mediaElement.captureStream()</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref('MediaStream')}} object which can be used as a source for audio and/or video data by other media processing code, or as a source for <a href="/en-US/docs/Glossary/WebRTC">WebRTC</a>.</p>

<h2 id="Example">Example</h2>

<p>In this example, an event handler is established so that clicking a button starts capturing the contents of a media element with the ID <code>"playback"</code> into a {{domxref("MediaStream")}}. The stream can then be used for other purposes—like a source for streaming over WebRTC, to allow sharing prerecorded videos with another person during a video call.</p>

<pre class="brush: js">document.querySelector('.playAndRecord').addEventListener('click', function() {
  var playbackElement = document.getElementById("playback");
  var captureStream = playbackElement.captureStream();
  playbackElement.play();
});
</pre>

<p>See <a href="/en-US/docs/Web/API/MediaStream_Recording_API/Recording_a_media_element">Recording a media element</a> for a longer and more intricate example and explanation.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Media Capture DOM Elements','#dom-htmlmediaelement-capturestream','captureStream()')}}</td>
   <td>{{Spec2('Media Capture DOM Elements')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.HTMLMediaElement.captureStream")}}</p>

<h3 id="Firefox-specific_notes">Firefox-specific notes</h3>
</div>

<p>Prior to Firefox 51, you couldn't use <code>captureStream()</code> on a media element whose source is, itself, a {{domxref("MediaStream")}} (like a {{HTMLElement("video")}} element which is presenting a stream being received over a {{domxref("RTCPeerConnection")}}). Beginning in Firefox 51, this works. This means you can capture a stream from the video element and use {{domxref("MediaRecorder")}} to record it. See {{bug(1259788)}} for details.</p>

<p>However, <code>captureStream()</code> is still prefixed as <code>mozCaptureStream()</code> on Firefox for good reason: there are some quirks in the present implementation which are worth noting:</p>

<ul>
 <li>The Firefox implementation currently only works as described in the specification when the media element's source is, itself, a {{domxref("MediaStream")}}.</li>
 <li>If the media element's source isn't a <code>MediaStream</code>, the output from this method isn't compatible with the spec, and if you change the source after starting capture, the output capture stream can't accept the new source data due to that incompatibility, so no {{domxref("MediaStreamTrack")}}s from the new source <code>MediaStream</code> are added to the captured stream, resulting in output that doesn't capture the updated source.</li>
 <li>Switching the source back to a <code>MediaStream</code> adds tracks back to the stream and it works again as expected.</li>
 <li>Calling <code>mozCaptureMediaStream()</code> on an element with a <code>MediaStream</code> source returns a stream that only contains tracks while the element is playing a <code>MediaStream</code>.</li>
 <li>If you call <code>mozCaptureMediaStream()</code> on a media element with no source media, its compatibility mode will be based on the first source that's added; for example, if it's a <code>MediaStream</code>, then the capture stream will only work with MediaStream sources from then on.</li>
 <li>This special behavior will be removed once the non-<code>MediaStream</code> source support is brought up to specification and the method is unprefixed. See {{bug(1259788, "bug", 160)}} for details.</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/MediaStream_Recording_API/Recording_a_media_element">Recording a media element</a></li>
 <li><a href="/en-US/docs/Web/API/MediaStream_Recording_API">MediaStream Recording API</a></li>
 <li>{{domxref("HTMLCanvasElement.captureStream()")}}</li>
 <li>{{domxref("MediaStream")}}</li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
</ul>
